# pycfhelpers

Python SDK wrapper module. Mandatory for each plugin.

Consists of two parts:

### common 
common helper functions.\
In common part, you cannot use any imports from the node SDK.

### node 
tools for working with nodes

NOTE: pychelpers root directory files will be removed.

### Setting up and Using flake8 for Code Quality Checks

This project uses flake8 for code quality checks. flake8 helps to identify potential issues and improve code readability by following PEP 8 guidelines.

#### Installing flake8

1. **Install flake8**:
   
   To install flake8, run the following command in your terminal:

   ```sh
   pip install flake8
   ```
2. **flake8 Configuration**
The .flake8 configuration file is already set up and located in the root directory of the project

3. **Integrating flake8 with VS Code**

- Install the Python extension for VS Code.

- Open VS Code settings (Ctrl + , or Cmd + , on Mac).

- Add the following settings to your project's settings.json file or to the global VS Code settings:

```json
{
    "python.linting.enabled": true,
    "python.linting.flake8Enabled": true,
    "python.linting.flake8Path": "flake8",
    "python.linting.flake8Args": [
        "--config=.flake8"
    ]
}
```
These steps will allow flake8 to automatically check your code and highlight issues in VS Code.